// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: supervise.proto
// Original file comments:
//  Copyright (C) 2012-2022 by László Nagy
// This file is part of Bear.
//
// Bear is a tool to generate compilation database for clang tooling.
//
// Bear is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Bear is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef GRPC_supervise_2eproto__INCLUDED
#define GRPC_supervise_2eproto__INCLUDED

#include "supervise.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace rpc {

// This represents a (remote) supervisor process to set up program execution.
//
// A supervisor process executes a single program in the hope that it can
// get information about the state of the child process. But to decide what
// is the right strategy to intercept the relevant events from the child
// process is done in the external supervisor process.
//
// This interface describes a remote service which can be queried for how to
// execute the child program. Can resolve the executable name or update the
// environment variables.
class Supervisor final {
 public:
  static constexpr char const* service_full_name() {
    return "rpc.Supervisor";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Resolve the execution for future child process.
    virtual ::grpc::Status Resolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::rpc::ResolveResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>> AsyncResolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>>(AsyncResolveRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>> PrepareAsyncResolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>>(PrepareAsyncResolveRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Resolve the execution for future child process.
      virtual void Resolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Resolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>* AsyncResolveRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>* PrepareAsyncResolveRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status Resolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::rpc::ResolveResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>> AsyncResolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>>(AsyncResolveRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>> PrepareAsyncResolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>>(PrepareAsyncResolveRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void Resolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, std::function<void(::grpc::Status)>) override;
      void Resolve(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>* AsyncResolveRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>* PrepareAsyncResolveRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_Resolve_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Resolve the execution for future child process.
    virtual ::grpc::Status Resolve(::grpc::ServerContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_Resolve : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Resolve() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_Resolve() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Resolve(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResolve(::grpc::ServerContext* context, ::rpc::ResolveRequest* request, ::grpc::ServerAsyncResponseWriter< ::rpc::ResolveResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_Resolve<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_Resolve : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Resolve() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::rpc::ResolveRequest, ::rpc::ResolveResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response) { return this->Resolve(context, request, response); }));}
    void SetMessageAllocatorFor_Resolve(
        ::grpc::MessageAllocator< ::rpc::ResolveRequest, ::rpc::ResolveResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::rpc::ResolveRequest, ::rpc::ResolveResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Resolve() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Resolve(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Resolve(
      ::grpc::CallbackServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_Resolve<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_Resolve : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Resolve() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_Resolve() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Resolve(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_Resolve : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Resolve() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_Resolve() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Resolve(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResolve(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Resolve : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Resolve() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Resolve(context, request, response); }));
    }
    ~WithRawCallbackMethod_Resolve() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Resolve(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Resolve(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Resolve : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Resolve() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::rpc::ResolveRequest, ::rpc::ResolveResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::rpc::ResolveRequest, ::rpc::ResolveResponse>* streamer) {
                       return this->StreamedResolve(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Resolve() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Resolve(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResolve(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::rpc::ResolveRequest,::rpc::ResolveResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_Resolve<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_Resolve<Service > StreamedService;
};

}  // namespace rpc


#endif  // GRPC_supervise_2eproto__INCLUDED
